#ifndef TARGET_SOLUTION
#pragma once 

#include "Mesh.hpp"
#include "..\Types\Shader.hpp"
#include <GL\glew.h>
#include "..\Types\Shadow.hpp"

#define CUBE_VERTEX_COUNT 24
#define CUBE_INDEX_COUNT 36


namespace scene{
	class Cube : public Mesh{
	public:
		Cube(glm::mat4& matrix, types::Shader* shader, types::Texture* texture);
		virtual ~Cube();
		virtual void update(float deltaT);
		virtual void draw(Shadow* shadow);
		void drawShadow(Shader* shadowShader, Shadow* shadow);
	private:
		GLuint vao;
		GLuint positionBuffer, indexBuffer, normalsBuffer, uvBuffer;
		types::Shader* shader;
		types::Texture* texture;
		static const float positions[CUBE_VERTEX_COUNT * 3];
		static const float normals[CUBE_VERTEX_COUNT * 3];
		static const unsigned int indices[CUBE_INDEX_COUNT];
		static const float uvs[CUBE_VERTEX_COUNT * 2];

	};
};



#endif