#include "Mesh.hpp"
#include <glm\gtc\matrix_transform.hpp>
#include <iostream>

Mesh::Mesh(glm::mat4& _modelMatrix)
	:modelMatrix(_modelMatrix)
{
}

Mesh::~Mesh(){

}

void Mesh::translate(glm::vec3 translation) {
	modelMatrix = glm::translate(modelMatrix, translation);
}

void Mesh::scale(glm::vec3 scale) {
	modelMatrix = glm::scale(modelMatrix, scale);
}

void Mesh::rotate(glm::vec3 rotation, float deltaT) {
	modelMatrix = glm::rotate(modelMatrix, deltaT, rotation);
}

void Mesh::bump(float deltaT) {
	if (bumper < 0) {
		bumper = 0;
	}
	if (bumper <= 1) {
		modelMatrix = glm::translate(modelMatrix, glm::vec3(0, deltaT, 0));
	}
	else {
		modelMatrix = glm::translate(modelMatrix, glm::vec3(0, -deltaT, 0));
	}
	bumper += deltaT;
	if (bumper >= 2) {
		bumper = 0;
	}
}


