#pragma once 

#include <glm/glm.hpp>
#include "../Scene/SceneObject.hpp"
#include "../Types/Shader.hpp"
#include "../Types/Texture.hpp"
#include <iostream>
using namespace types;
using namespace scene;
class Mesh{

public:
	Mesh(glm::mat4& _modelMatrix);
	Mesh(void) {};
	virtual ~Mesh(void);

	Texture* diffuse;
	virtual void update(float delta) {};
	virtual void draw() {};

	types::Texture* texture;
	glm::mat4 modelMatrix;

	void translate(glm::vec3 translation);
	void scale(glm::vec3 scale);
	void rotate(glm::vec3 rotation, float deltaT);
	void bump(float deltaT);

protected:
	double bumper = 0;
};